# Class DisplayPanel

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
org.openscience.jmol.app.jmolpanel.DisplayPanel

All Implemented Interfaces:
  `ComponentListener, ImageObserver, MenuContainer, Printable, Serializable, EventListener, Accessible, JmolFrame`

Direct Known Subclasses:
  `NMR_DisplayPanel`

public class DisplayPanel extends JPanel implements JmolFrame, ComponentListener, Printable

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`DisplayPanel.CheckBoxMenuItemAction`
Action calling evalStringQuiet(<action> + CheckBoxState)
`protected class`
`DisplayPanel.MoveToAction`
Action calling moveTo()
`protected class`
`DisplayPanel.SetStatusAction`
Action calling setStatus()

### Nested classes/interfaces inherited from class JPanel

`JPanel.AccessibleJPanel`

### Nested classes/interfaces inherited from class JComponent

`JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class Container

`Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected Action`
`axesAction`
`protected Action`
`bottomAction`
`protected Action`
`boundboxAction`
`AbstractButton`
`buttonModelkit`
`AbstractButton`
`buttonRotate`
`protected org.openscience.jmol.app.jmolpanel.DisplayPanel.DefineCenterAction`
`defineCenterAction`
`protected Action`
`deleteAction`
`protected final Dimension`
`dimSize`
`protected String`
`displaySpeed`
`protected JFrame`
`frame`
`protected Action`
`frontAction`
`protected boolean`
`haveDisplay`
`protected org.openscience.jmol.app.jmolpanel.DisplayPanel.HomeAction`
`homeAction`
`protected Action`
`hydrogensAction`
`protected JmolPanel`
`jmolPanel`
`protected int`
`lastMotionEventNumber`
`protected Action`
`leftAction`
`protected Action`
`measurementsAction`
`protected Action`
`perspectiveAction`
`protected final Rectangle`
`rectClip`
`protected Action`
`rightAction`
`protected boolean`
`showPaintTime`
`protected Dimension`
`startupDim`
`protected long`
`timeBegin`
`protected static int`
`timeCount`
`protected static int`
`timeLast`
`protected static int`
`timeTotal`
`protected Action`
`topAction`
`protected Viewer`
`vwr`
`protected Action`
`xlateAction`
`protected Action`
`zoomAction`

### Fields inherited from class JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Fields inherited from interface Printable

`NO_SUCH_PAGE, PAGE_EXISTS`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`DisplayPanel(JmolPanel jmolPanel)`

## Method Summary

Modifier and Type
Method
Description
`void`
`addActions(List<Action> actions)`
`void`
`componentHidden(ComponentEvent e)`
`void`
`componentMoved(ComponentEvent e)`
`void`
`componentResized(ComponentEvent e)`
`void`
`componentShown(ComponentEvent e)`
`protected String`
`fmt(int num)`
`JFrame`
`getFrame()`
`void`
`paint(Graphics g)`
`int`
`print(Graphics g, PageFormat pf, int pageIndex)`
`protected void`
`recordTime(int time)`
`protected void`
`resetTimes()`
`void`
`say(String msg)`
`void`
`setJmolSize(Dimension d)`
`void`
`setViewer(Viewer vwr)`
`protected void`
`showTimes()`
`void`
`start()`
`protected void`
`startPaintClock()`
`protected void`
`stopPaintClock()`
`protected void`
`updateSize(boolean doAll)`

### Methods inherited from class JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### vwr

protected Viewer vwr

### displaySpeed

protected String displaySpeed

### startupDim

protected Dimension startupDim

### haveDisplay

protected boolean haveDisplay

### frame

protected JFrame frame

### jmolPanel

protected JmolPanel jmolPanel

### showPaintTime

protected boolean showPaintTime

### dimSize

protected final Dimension dimSize

### rectClip

protected final Rectangle rectClip

### buttonRotate

public AbstractButton buttonRotate

### buttonModelkit

public AbstractButton buttonModelkit

### homeAction

protected org.openscience.jmol.app.jmolpanel.DisplayPanel.HomeAction homeAction

### defineCenterAction

protected org.openscience.jmol.app.jmolpanel.DisplayPanel.DefineCenterAction defineCenterAction

### frontAction

protected Action frontAction

### topAction

protected Action topAction

### bottomAction

protected Action bottomAction

### rightAction

protected Action rightAction

### leftAction

protected Action leftAction

### hydrogensAction

protected Action hydrogensAction

### measurementsAction

protected Action measurementsAction

### perspectiveAction

protected Action perspectiveAction

### axesAction

protected Action axesAction

### boundboxAction

protected Action boundboxAction

### deleteAction

protected Action deleteAction

### zoomAction

protected Action zoomAction

### xlateAction

protected Action xlateAction

### timeLast

protected static int timeLast

### timeCount

protected static int timeCount

### timeTotal

protected static int timeTotal

### timeBegin

protected long timeBegin

### lastMotionEventNumber

protected int lastMotionEventNumber

## Constructor Details

### DisplayPanel

protected DisplayPanel(JmolPanel jmolPanel)

## Method Details

### getFrame

public JFrame getFrame()

Specified by:
  `getFrame` in interface `JmolFrame`

### say

public void say(String msg)

### setViewer

public void setViewer(Viewer vwr)

### start

public void start()

### componentHidden

public void componentHidden(ComponentEvent e)

Specified by:
  `componentHidden` in interface `ComponentListener`

### componentMoved

public void componentMoved(ComponentEvent e)

Specified by:
  `componentMoved` in interface `ComponentListener`

### componentResized

public void componentResized(ComponentEvent e)

Specified by:
  `componentResized` in interface `ComponentListener`

### componentShown

public void componentShown(ComponentEvent e)

Specified by:
  `componentShown` in interface `ComponentListener`

### updateSize

protected void updateSize(boolean doAll)

### paint

public void paint(Graphics g)

Overrides:
  `paint` in class `JComponent`

### print

public int print(Graphics g, PageFormat pf, int pageIndex)

Specified by:
  `print` in interface `Printable`

### addActions

public void addActions(List<Action> actions)

### resetTimes

protected void resetTimes()

### recordTime

protected void recordTime(int time)

### startPaintClock

protected void startPaintClock()

### stopPaintClock

protected void stopPaintClock()

### fmt

protected String fmt(int num)

### showTimes

protected void showTimes()

### setJmolSize

public void setJmolSize(Dimension d)